<template>
    <div class="trackslist">
        <button class="add-track" @click="addTrack()">Add a new track</button>
        <div class="track" v-for="(track, i) in tracks" :key="i">
            <div class="track-wrapper">
                <div class="node" v-for="(node, j) in track.nodes" :key="j">
                    <div class="inner-node">
                        <gain-node-wrapper :node="node" v-if="node.type == 'gain'" />
                        <oscillator-wrapper :node="node" v-if="node.type == 'oscillator'" />
                        <destination-wrapper :node="node" v-if="node.type == 'destination'" />
                    </div>
                    <div class="drop-zone" v-if="node.type != 'destination'">
                        <select @change="addNode(track, $event, node)">
                            <option value = "">-</option>
                            <option value="gain">Volume</option>
                        </select>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script type="ts">
import { defineComponent } from 'vue'
import { AudioTrack } from '../lib/audio/AudioTrack.ts'
import GainNodeWrapper from './nodes/GainNodeWrapper.vue'
import OscillatorWrapper from './nodes/OscillatorWrapper.vue'
import DestinationWrapper from './nodes/DestinationWrapper.vue'

export default defineComponent({
  components: { GainNodeWrapper, OscillatorWrapper, DestinationWrapper },
    name: "Trackslist",
    data() {
        return {
            tracks: [],
            audioContext: new AudioContext()
        }
    },
    methods: {
        addTrack() {
            this.tracks.push(new AudioTrack(this.audioContext))
        },
        addNode(track, e, after) {
            if (e.target.value !== "") {
                track.addNode(after, e.target.value, this.getName());
            }
        },
        getName() {
            return Math.floor(Math.random() * 1000);
        }
    }
})
</script>

<style>
    .float-left {
        float: left;
    }
    .track {
        height: 50px;;
        margin: 10px 0;
        padding: 10px;
        background-color: silver;
        overflow-x: auto;
        overflow-y: auto;
    }
    .track-wrapper {
        display: flex;
    }
    .node {
        background-color: white;
        padding: 0 10px;
        height: 50px;
        text-align: center;
        vertical-align: middle;
        line-height:  50px;
        margin-right: 10px;
        display: flex;
    }
    .inner-node {
        margin-right: 10px;
    }
</style>